<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="generator" content="Docutils 0.21.2: https://docutils.sourceforge.io/" />
<title>hg serve</title>
<link rel="stylesheet" href="../style.css" type="text/css" />
</head>
<body>
<div class="document" id="hg-serve">
<span id="hg-serve-1"></span>
<h1 class="title">hg serve</h1>
<h2 class="subtitle" id="start-stand-alone-webserver">start stand-alone webserver</h2>

<div class="contents htmlonly topic" id="contents">
<p class="topic-title"><a class="reference internal" href="#top">Contents</a></p>
<ul class="simple">
<li><a class="reference internal" href="#synopsis" id="toc-entry-1">Synopsis</a></li>
<li><a class="reference internal" href="#description" id="toc-entry-2">Description</a></li>
<li><a class="reference internal" href="#options" id="toc-entry-3">Options</a></li>
</ul>
</div>
<div class="section" id="synopsis">
<h1><a class="toc-backref" href="#contents">Synopsis</a></h1>
<pre class="literal-block">
hg serve [OPTION]...
</pre>
</div>
<div class="section" id="description">
<h1><a class="toc-backref" href="#contents">Description</a></h1>
<p>Start a local HTTP repository browser and pull server. You can use
this for ad-hoc sharing and browsing of repositories. It is
recommended to use a real web server to serve a repository for
longer periods of time.</p>
<p>Please note that the server does not implement access control.
This means that, by default, anybody can read from the server and
nobody can write to it by default. Set the <tt class="docutils literal"><span class="pre">web.allow-push</span></tt>
option to <tt class="docutils literal">*</tt> to allow everybody to push to the server. You
should use a real web server if you need to authenticate users.</p>
<p>By default, the server logs accesses to stdout and errors to
stderr. Use the -A/--accesslog and -E/--errorlog options to log to
files.</p>
<p>To have the server choose a free port number to listen on, specify
a port number of 0; in this case, the server will print the port
number it uses.</p>
<p>Returns 0 on success.</p>
</div>
<div class="section" id="options">
<h1><a class="toc-backref" href="#contents">Options</a></h1>
<table class="docutils option-list" frame="void" rules="none">
<col class="option" />
<col class="description" />
<tbody valign="top">
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-A</span>, <span class="option">--accesslog <var>&lt;FILE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>name of access log file to write to</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-d</span>, <span class="option">--daemon</span></kbd></td>
<td>run server in background</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">--daemon-postexec <var>&lt;VALUE[+]&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>used internally by daemon mode</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-E</span>, <span class="option">--errorlog <var>&lt;FILE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>name of error log file to write to</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-p</span>, <span class="option">--port <var>&lt;PORT&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>port to listen on (default: 8000)</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-a</span>, <span class="option">--address <var>&lt;ADDR&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>address to listen on (default: all interfaces)</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">--prefix <var>&lt;PREFIX&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>prefix path to serve from (default: server root)</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-n</span>, <span class="option">--name <var>&lt;NAME&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>name to show in web pages (default: working directory)</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">--web-conf <var>&lt;FILE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>name of the hgweb config file (see 'hg help hgweb')</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">--webdir-conf <var>&lt;FILE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>name of the hgweb config file (DEPRECATED)</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">--pid-file <var>&lt;FILE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>name of file to write process ID to</td></tr>
<tr><td class="option-group">
<kbd><span class="option">--stdio</span></kbd></td>
<td>for remote clients (ADVANCED)</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">--cmdserver <var>&lt;MODE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>for remote clients (ADVANCED)</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-t</span>, <span class="option">--templates <var>&lt;TEMPLATE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>web templates to use</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">--style <var>&lt;STYLE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>template style to use</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-6</span>, <span class="option">--ipv6</span></kbd></td>
<td>use IPv6 instead of IPv4</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">--certificate <var>&lt;FILE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>SSL certificate file</td></tr>
<tr><td class="option-group">
<kbd><span class="option">--print-url</span></kbd></td>
<td>start and print only the URL</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-S</span>, <span class="option">--subrepos</span></kbd></td>
<td>recurse into subrepositories</td></tr>
</tbody>
</table>
<p>[+] marked option can be specified multiple times</p>
</div>
</div>
</body>
</html>
